# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2012-12-21.      #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generator git on tinkerforge.com                   #
#############################################################

module Tinkerforge
  # Device for output of voltage between 0 and 5V
  class BrickletAnalogOut < Device

    FUNCTION_SET_VOLTAGE = 1 # :nodoc:
    FUNCTION_GET_VOLTAGE = 2 # :nodoc:
    FUNCTION_SET_MODE = 3 # :nodoc:
    FUNCTION_GET_MODE = 4 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon

      @api_version = [1, 0, 0]

      @response_expected[FUNCTION_SET_VOLTAGE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_VOLTAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MODE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

    end

    # Sets the voltage in mV. The possible range is 0V to 5V (0-5000).
    # Calling this function will set the mode to 0 (see BrickletAnalogOut#set_mode).
    # 
    # The default value is 0 (with mode 1).
    def set_voltage(voltage)
      send_request(FUNCTION_SET_VOLTAGE, [voltage], 'S', 0, '')
    end

    # Returns the voltage as set by BrickletAnalogOut#set_voltage.
    def get_voltage
      send_request(FUNCTION_GET_VOLTAGE, [], '', 2, 'S')
    end

    # Sets the mode of the analog value. Possible modes:
    # 
    # * 0: Normal Mode (Analog value as set by BrickletAnalogOut#set_voltage is applied
    # * 1: 1k Ohm resistor to ground
    # * 2: 100k Ohm resistor to ground
    # * 3: 500k Ohm resistor to ground
    # 
    # Setting the mode to 0 will result in an output voltage of 0. You can jump
    # to a higher output voltage directly by calling BrickletAnalogOut#set_voltage.
    # 
    # The default mode is 1.
    def set_mode(mode)
      send_request(FUNCTION_SET_MODE, [mode], 'C', 0, '')
    end

    # Returns the mode as set by BrickletAnalogOut#set_mode.
    def get_mode
      send_request(FUNCTION_GET_MODE, [], '', 1, 'C')
    end

    # Returns the UID, the UID where the Bricklet is connected to, 
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c' or 'd'.
    # 
    # The device identifiers are:
    # 
    #  "Device Identifier", "Device"
    # 
    #  "11", "Brick DC"
    #  "12", "Brick Debug"
    #  "13", "Brick Master 2.0"
    #  "14", "Brick Servo"
    #  "15", "Brick Stepper"
    #  "16", "Brick IMU"
    #  "", ""
    #  "21", "Bricklet Ambient Light"
    #  "22", "Bricklet Breakout"
    #  "23", "Bricklet Current12"
    #  "24", "Bricklet Current25"
    #  "25", "Bricklet Distance IR"
    #  "26", "Bricklet Dual Relay"
    #  "27", "Bricklet Humidity"
    #  "28", "Bricklet IO-16"
    #  "29", "Bricklet IO-4"
    #  "210", "Bricklet Joystick"
    #  "211", "Bricklet LCD 16x2"
    #  "212", "Bricklet LCD 20x4"
    #  "213", "Bricklet Linear Poti"
    #  "214", "Bricklet Piezo Buzzer"
    #  "215", "Bricklet Rotary Poti"
    #  "216", "Bricklet Temperature"
    #  "217", "Bricklet Temperature IR"
    #  "218", "Bricklet Voltage"
    #  "219", "Bricklet Analog In"
    #  "220", "Bricklet Analog Out"
    #  "221", "Bricklet Barometer"
    #  "222", "Bricklet GPS"
    #  "223", "Bricklet Industrial Digital In 4"
    #  "224", "Bricklet Industrial Digital Out 4"
    #  "225", "Bricklet Industrial Quad Relay"
    #  "226", "Bricklet PTC"
    #  "227", "Bricklet Voltage/Current"
    # 
    # .. versionadded:: 2.0.0~(Plugin)
    def get_identity
      send_request(FUNCTION_GET_IDENTITY, [], '', 25, 'Z8 Z8 k C3 C3 S')
    end

  end
end
