# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2012-12-21.      #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generator git on tinkerforge.com                   #
#############################################################

module Tinkerforge
  # Device for controlling a piezo buzzer
  class BrickletPiezoBuzzer < Device

    # This callback is triggered if a beep set by BrickletPiezoBuzzer#beep is finished
    CALLBACK_BEEP_FINISHED = 3

    # This callback is triggered if the playback of the morse code set by
    # BrickletPiezoBuzzer#morse_code is finished.
    CALLBACK_MORSE_CODE_FINISHED = 4

    FUNCTION_BEEP = 1 # :nodoc:
    FUNCTION_MORSE_CODE = 2 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon

      @api_version = [1, 0, 0]

      @response_expected[FUNCTION_BEEP] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_MORSE_CODE] = RESPONSE_EXPECTED_FALSE
      @response_expected[CALLBACK_BEEP_FINISHED] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[CALLBACK_MORSE_CODE_FINISHED] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_BEEP_FINISHED] = ''
      @callback_formats[CALLBACK_MORSE_CODE_FINISHED] = ''
    end

    # Beeps with the duration in ms. For example: If you set a value of 1000,
    # the piezo buzzer will beep for one second.
    def beep(duration)
      send_request(FUNCTION_BEEP, [duration], 'L', 0, '')
    end

    # Sets morse code that will be played by the piezo buzzer. The morse code
    # is given as a string consisting of "." (dot), "-" (minus) and " " (space)
    # for *dits*, *dahs* and *pauses*. Every other character is ignored.
    # 
    # For example: If you set the string "...---...", the piezo buzzer will beep
    # nine times with the durations "short short short long long long short 
    # short short".
    # 
    # The maximum string size is 60.
    def morse_code(morse)
      send_request(FUNCTION_MORSE_CODE, [morse], 'Z60', 0, '')
    end

    # Returns the UID, the UID where the Bricklet is connected to, 
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c' or 'd'.
    # 
    # The device identifiers are:
    # 
    #  "Device Identifier", "Device"
    # 
    #  "11", "Brick DC"
    #  "12", "Brick Debug"
    #  "13", "Brick Master 2.0"
    #  "14", "Brick Servo"
    #  "15", "Brick Stepper"
    #  "16", "Brick IMU"
    #  "", ""
    #  "21", "Bricklet Ambient Light"
    #  "22", "Bricklet Breakout"
    #  "23", "Bricklet Current12"
    #  "24", "Bricklet Current25"
    #  "25", "Bricklet Distance IR"
    #  "26", "Bricklet Dual Relay"
    #  "27", "Bricklet Humidity"
    #  "28", "Bricklet IO-16"
    #  "29", "Bricklet IO-4"
    #  "210", "Bricklet Joystick"
    #  "211", "Bricklet LCD 16x2"
    #  "212", "Bricklet LCD 20x4"
    #  "213", "Bricklet Linear Poti"
    #  "214", "Bricklet Piezo Buzzer"
    #  "215", "Bricklet Rotary Poti"
    #  "216", "Bricklet Temperature"
    #  "217", "Bricklet Temperature IR"
    #  "218", "Bricklet Voltage"
    #  "219", "Bricklet Analog In"
    #  "220", "Bricklet Analog Out"
    #  "221", "Bricklet Barometer"
    #  "222", "Bricklet GPS"
    #  "223", "Bricklet Industrial Digital In 4"
    #  "224", "Bricklet Industrial Digital Out 4"
    #  "225", "Bricklet Industrial Quad Relay"
    #  "226", "Bricklet PTC"
    #  "227", "Bricklet Voltage/Current"
    # 
    # .. versionadded:: 2.0.0~(Plugin)
    def get_identity
      send_request(FUNCTION_GET_IDENTITY, [], '', 25, 'Z8 Z8 k C3 C3 S')
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
